package io.renren.modules.sys.controller;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;

import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import io.renren.common.annotation.LogOperation;
import io.renren.common.constant.Constant;
import io.renren.common.page.PageData;
import io.renren.common.utils.ExcelUtils;
import io.renren.common.utils.Result;
import io.renren.common.validator.AssertUtils;
import io.renren.common.validator.ValidatorUtils;
import io.renren.common.validator.group.AddGroup;
import io.renren.common.validator.group.DefaultGroup;
import io.renren.common.validator.group.UpdateGroup;
import io.renren.modules.sys.dao.LandingPagesDao;
import io.renren.modules.sys.dto.RdSmsLogDTO;
import io.renren.modules.sys.entity.LandingPagesEntity;
import io.renren.modules.sys.excel.RdSmsLogExcel;
import io.renren.modules.sys.service.RdSmsLogService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import springfox.documentation.annotations.ApiIgnore;


/**
 * 短信验证码记录
 *
 * @author Mark sunlightcs@gmail.com
 * @since 1.0.0 2022-06-05
 */
@RestController
@RequestMapping("sys/rdsmslog")
@Api(tags="短信验证码记录")
public class RdSmsLogController {
    @Autowired
    private RdSmsLogService rdSmsLogService;
    @Autowired
    private LandingPagesDao landingPagesDao;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("sys:rdsmslog:page")
    public Result<PageData<RdSmsLogDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<RdSmsLogDTO> page = rdSmsLogService.page(params);
        if (!CollectionUtils.isEmpty(page.getList())){
            List<RdSmsLogDTO> rdSmsLogDTOList = page.getList();
            for (RdSmsLogDTO smsLogDTO:rdSmsLogDTOList){
                if (smsLogDTO!=null && smsLogDTO.getPageId()!=null){
                    LandingPagesEntity landingPagesEntity = landingPagesDao.selectById(smsLogDTO.getPageId());
                    if (landingPagesEntity!=null && landingPagesEntity.getStatus()==1){
                        smsLogDTO.setPageName(landingPagesEntity.getName());
                    }
                }
            }
            page.setList(rdSmsLogDTOList);
        }

        return new Result<PageData<RdSmsLogDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("sys:rdsmslog:info")
    public Result<RdSmsLogDTO> get(@PathVariable("id") Long id){
        RdSmsLogDTO data = rdSmsLogService.get(id);

        return new Result<RdSmsLogDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("sys:rdsmslog:save")
    public Result save(@RequestBody RdSmsLogDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        rdSmsLogService.save(dto);

        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("sys:rdsmslog:update")
    public Result update(@RequestBody RdSmsLogDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        rdSmsLogService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("sys:rdsmslog:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");

        rdSmsLogService.delete(ids);

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("sys:rdsmslog:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<RdSmsLogDTO> list = rdSmsLogService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, RdSmsLogExcel.class);
    }

}